import pygame,sys,os,pickle

try:
        from tkinter import *
        from tkinter.filedialog import askopenfilename
        from tkinter.filedialog import asksaveasfilename
except ImportError:
        from Tkinter import *
        from tkFileDialog import askopenfilename
        from tkFileDialog import asksaveasfilename
    
from pygame.locals import *

os.environ["SDL_VIDEO_CENTERED"] = "1"
pygame.init()

#screen size should be decided by a variable in a settings file
mySettings = open("settings.txt")
for line in mySettings:  #obviously doesn't require a for loop but I'm lazy
        line = line[1:-1].split(",")
        size = int(line[0]),int(line[1])
        mySettings.close()
        break
screen1     = pygame.display.set_mode(size)
realscreen  = pygame.Surface((1500,700))
scalefactor = (float(realscreen.get_width())/float(screen1.get_width()),float(realscreen.get_height())/float(screen1.get_height()))

#blocks mousemotion from appearing on the que
pygame.event.set_blocked(MOUSEMOTION) 


#get graphics for the level editor
def getgraphics(directory):
    dirlist = os.listdir(directory)
    graphic = {}
    for graf in dirlist:
        if graf[-3:] == "png":
            graphic[graf[:-4]] = pygame.image.load(os.path.join(directory,graf)).convert_alpha()
    return graphic

graphic = getgraphics("../graphics")
pallet = {}
pallet[1]   = graphic["texftile"]
pallet[2]   = graphic["aztecsheet"]
pallet[3]   = graphic["dinosheet"]
pallet[4]   = graphic["dungeon1"]
pallet[5]   = graphic["aztectemple"]
pallet[6]   = graphic["aztectemple2"]

bg         = graphic["bgtiles"]
tweaktiles = graphic["levtweak"]

enemyplace    = {}
enemyplace[1] = graphic["enemyplace1"]
enemyplace[2] = graphic["enemyplace2"]

bossplace     = {}
bossplace[1]  = graphic["bossplace1"]


class Newmap:
        def __init__(self,screen):
                self.pallet  = pallet
                self.screen  = screen
                self.current = {}
                self.bgstate = {}
                self.tweaks      = {}
                self.painttweaks = {}
                self.enemy       = []

                #added in the new version
                self.state       = "BACK"
                self.nextstate   = None ##
                self.bgready     = False
                self.editready   = False
                self.target      = (None,None)
                self.x,self.y    = None,None

                self.specials    = {}
                self.specials["push"]  = {}
                self.specials["burn"]  = {}
                self.specials["break"] = {}
                self.specials["door"]  = {} ##
                
                self.pal     = 0
                self.bg      = bg
                self.bgcolor = (0,0,0)
                self.bgstate["colour"] = self.bgcolor
                self.custom = False
                self.foreon = False

                self.accessed   = False #this will be set to true if not run as main
                self.addnew     = False #used for adding new maps from the world map generator
                self.addednew   = False
                self.savedas    = None
                self.savechange = True


        def bgedit_init(self):
            self.bgstart = pygame.Surface((1500,700)).convert_alpha()
            self.bgstart.fill((0,0,0),(0,0,500,700))
            self.bgstart.blit(self.bg,(50,0))
            if self.accessed == True: 
                self.bgstart.blit(graphic["altoptions"],(50,650))
            self.bgstart.fill((255,0,0),(0,0,5,700))
            self.bgstart.fill((255,0,0),(495,0,5,700))
            self.bgready = True
            
        def bgeditor(self):
                if not self.bgready:
                    self.bgedit_init()
                    self.screen.blit(self.bgstart,(0,0),(0,0,500,700))

                if self.custom == False:
                        pygame.draw.rect(self.screen,(255,0,0),(100,402,100,49),3)
                else:
                        pygame.draw.rect(self.screen,(255,0,0),(250,402,100,49),3)
                if self.foreon == True:
                        pygame.draw.rect(self.screen,(0,0,255),(250,576,100,49),3)
                else:
                        pygame.draw.rect(self.screen,(0,0,255),(100,576,100,49),3)
                                        
                for click in pygame.event.get():
                        if click.type == pygame.MOUSEBUTTONDOWN:
                            hit = pygame.mouse.get_pressed()
                            if hit[0]:
                                self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])

                                if 50 <= self.target[0] <= 450 and 0 <= self.target[1] <= 350:
                                    #select square from background pallet for custom mode
                                    if self.custom == True:
                                            self.x, self.y = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                                            self.screen.fill((0,0,0),(5,0,490,400))
                                            self.screen.blit(self.bg,(50,0),(0,0,400,400))
                                            pygame.draw.rect(self.screen,(255,0,0),(self.x-1,self.y-1,52,52),2)

                                    #fill entire background with a single color
                                    elif self.custom == False:
                                            self.bgcolor = tuple(self.screen.get_at((self.target[0],self.target[1])))
                                            self.bgstate["colour"] = self.bgcolor
                                            paintback(self.screen,self.bgstate)
                                            if self.foreon: paintfromdict(self.screen,self.current) #is the foreground visible?
                                            self.savechange = False


                                # paint background square by square in custom mode            
                                elif 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                                    d1,d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50                                
                                    try:
                                            self.bgstate[(d1,d2)] = (self.x-50,self.y,50,50)
                                            self.savechange = False
                                    except: print("select something you idiot")
                                    paintback(self.screen,self.bgstate)
                                    if self.foreon: paintfromdict(self.screen,self.current)
                                    


                                #switch between "Fill All" and "Custom" select
                                elif 100 <= self.target[0] <= 200 and 400 <= self.target[1] <= 450:
                                        self.screen.blit(self.bgstart,(5,401),(5,401,490,52))
                                        pygame.draw.rect(self.screen,(255,0,0),(100,402,100,49),3)
                                        self.custom = False
                                elif 250 <= self.target[0] <= 350 and 400 <= self.target[1] <= 450:
                                        self.screen.blit(self.bgstart,(5,401),(5,401,490,52))
                                        pygame.draw.rect(self.screen,(255,0,0),(250,402,100,49),3)
                                        self.custom = True

                                #switch between "foreground on" and "foreground off"
                                elif 100<= self.target[0] <= 200 and 575 <= self.target[1] <= 625:
                                        self.screen.blit(self.bgstart,(0,576),(0,576,500,52))
                                        pygame.draw.rect(self.screen,(0,0,255),(100,577,100,49),3)
                                        paintback(self.screen,self.bgstate)
                                        self.foreon = False
                                elif 250 <= self.target[0] <= 350 and 575 <= self.target[1] <= 625:
                                        self.screen.blit(self.bgstart,(0,576),(0,576,500,52))
                                        pygame.draw.rect(self.screen,(0,0,255),(250,577,100,49),3)
                                        paintfromdict(self.screen,self.current)
                                        self.foreon = True        

                                #move to foreground editor
                                elif 50 <= self.target[0] <= 200 and 650 <=self.target[1] <= 700:
                                        self.custom  = True
                                        self.bgready = False
                                        self.state   = "FORE"
                                        paintfromdict(self.screen,self.current)
                                        
                                #load or switch to tweaker depending on access
                                elif 370 <= self.target[0]<= 450 and 650 <= self.target[1] <= 700:
                                        if not self.accessed:
                                            self.load_map()
                                        else:
                                            if self.savechange == False:
                                                    self.state     = "SAVE"
                                                    self.nextstate = "TWEAK"
                                            else:
                                                    self.state       = "TWEAK"
                                                    self.bgready     = False
                                                    self.editready   = False
                                                    self.addnew      = False
                                    

                                #if running from world map switch map to world editor
                                elif 250 <= self.target[0]<= 330 and 650 <= self.target[1] <= 700:
                                        if self.accessed:
                                                if self.savechange == False:
                                                        self.state     = "SAVE"
                                                        self.nextstate = "WORLD"
                                                else:
                                                        self.state       = "WORLD"
                                                        self.bgready     = False
                                                        self.editready   = False
                                                        self.addnew      = False

                            #right clicking deletes the cell
                            elif hit[2]:
                                self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])
                                d1, d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                                if ((d1,d2)) in self.bgstate and 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                                        self.screen.fill(self.bgcolor,(d1,d2,50,50))
                                        if self.foreon: paintfromdict(self.screen,self.current)
                                        self.bgstate.pop((d1,d2))
                                        self.savechange = False
                                    
                        if click.type == pygame.QUIT: self.state = "QUIT"
                                    

        def loadpallet(self):
                #supports multiple foreground pallets
                if self.pal < len(pallet): self.pal += 1
                elif self.pal == len(self.pallet): self.pal = 1
                self.screen.fill((0,0,0),(0,0,500,700))
                self.screen.blit(self.pallet[self.pal],(50,0))
                self.screen.fill((255,0,0),(0,0,5,700))
                self.screen.fill((255,0,0),(495,0,5,700))

        def load_map(self,file="ask"):
                try:
                        if file == "ask":
                                loaddata = pickle.load(open(askopenfilename(),'rb'))
                        else:
                                loaddata = pickle.load(open(file,'rb'))
                        try:
                                self.bgstate = loaddata["background"]
                                self.current = loaddata["main"]
                                if "tweaks" in loaddata:
                                        self.tweaks      = loaddata["tweaks"]
                                        self.painttweaks = loaddata["paintmaskdetails"]
                                        self.enemy       = loaddata["enemies"]
                        except TypeError: #old format was a list
                                print("Your file is saved in the old format")
                                print("resave in order to switch.")
                                self.bgstate = loaddata[0]
                                self.current = loaddata[1]
                        try:
                                self.specials = loaddata["specials"]
                        except: print("either no specials, or they failed to load")
                        paintback(self.screen,self.bgstate)
                        paintfromdict(self.screen,self.current)
                        self.custom = True; self.foreon = True
                        self.screen.blit(self.bgstart,(0,0),(0,0,500,700))
                        pygame.draw.rect(self.screen,(255,0,0),(250,402,100,49),3)
                        pygame.draw.rect(self.screen,(0,0,255),(250,577,100,49),3)
                except (IOError,TypeError): print("there was a loading issue")
        
        def editor(self):

                if not self.editready:
                    self.loadpallet()
                    self.editready = True

                for click in pygame.event.get():
                        if click.type == pygame.MOUSEBUTTONDOWN:
                            hit = pygame.mouse.get_pressed()
                            if hit[0]:
                                self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])

                                #select image from pallet
                                if 50 <= self.target[0] <= 450 and 50 <= self.target[1] <= 650:
                                    self.x, self.y = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                                    self.screen.fill((0,0,0),(5,0,490,700))
                                    self.screen.blit(self.pallet[self.pal],(50,0))
                                    pygame.draw.rect(self.screen,(255,0,0),(self.x-1,self.y-1,52,52),2)

                                #paint selected image on the screen
                                elif 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                                    d1,d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                                    try:
                                            self.current[(d1,d2)] = (self.pal,(self.x-50,self.y,50,50))
                                            self.savechange = False
                                    except: print("select something you idiot")
                                    paintback(self.screen,self.bgstate)
                                    paintfromdict(self.screen,self.current)

                                # return to background editor
                                elif 50 <= self.target[0] <= 200 and 650 <= self.target[1] <= 700:
                                    paintback(self.screen,self.bgstate)
                                    if self.foreon: paintfromdict(self.screen,self.current)
                                    self.state = "BACK"
                                    self.editready = False
                                    self.pal -= 1
                                    
                                #change pallet
                                elif 210 <= self.target[0] <= 360 and 650 <= self.target[1] <= 700:
                                        self.loadpallet()

                                #saving
                                elif 370 <= self.target[0] <= 470 and 650 <= self.target[1] <= 700:
                                        self.save()

                            #right clicking deletes the cell            
                            elif hit[2]:
                                self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])
                                d1, d2 = int(self.target[0]/50)*50, int(self.target[1]/50)*50
                                if ((d1,d2)) in self.current and 500 <= self.target[0] <= 1500 and 0 <= self.target[1] <= 700:
                                        self.current.pop((d1,d2))
                                        self.savechange = False
                                        paintback(self.screen,self.bgstate)
                                        paintfromdict(self.screen,self.current)
                                        
                        if click.type == pygame.QUIT: self.state = "QUIT"

        def save(self):
                mapdata  = {}
                mapdata["background"]       = self.bgstate
                mapdata["main"]             = self.current
                mapdata["tweaks"]           = self.tweaks
                mapdata["paintmaskdetails"] = self.painttweaks
                mapdata["enemies"]          = self.enemy
                mapdata["specials"]         = self.specials
                try:
                        choosename = asksaveasfilename()
                        filename = open(choosename,'wb')
                        pickle.dump(mapdata,filename)
                        filename.close()
                        self.savechange = True
                        self.savedas  = choosename
                        if self.addnew == True:
                                self.addednew = True
                                self.addnew   = False          
                except IOError:
                        if self.nextstate != None:
                                self.nextstate = None
                                self.state = "BACK"
                                paintback(self.screen,self.bgstate)
                                paintfromdict(self.screen,self.current)
                                
                
        def savequery(self):
                self.screen.blit(graphic["savequery"],(750,200))
                for click in pygame.event.get():
                        if click.type == pygame.MOUSEBUTTONDOWN:
                            hit = pygame.mouse.get_pressed()
                            if hit[0]:
                                self.target = int(pygame.mouse.get_pos()[0]*scalefactor[0]),int(pygame.mouse.get_pos()[1]*scalefactor[1])

                                if (750+50) <= self.target[0] <= (750+150) and (200+140) <= self.target[1] <= (200+175):
                                        self.save()
                                        if self.savechange == True:
                                                self.state     = self.nextstate
                                                self.nextstate = None
                                                self.bgready     = False
                                                self.editready   = False
                                                self.addnew      = False
                                elif (750+200) <= self.target[0] <= (750+300) and (200+140) <= self.target[1] <= (200+175):
                                        self.savechange = True
                                        self.state      = self.nextstate
                                        self.nextstate  = None
                                        self.bgready     = False
                                        self.editready   = False
                                        self.addnew      = False
                                elif (750+350) <= self.target[0] <= (750+450) and (200+140) <= self.target[1] <= (200+175):
                                        self.nextstate = None
                                        self.state = "BACK"
                                        paintback(self.screen,self.bgstate)
                                        paintfromdict(self.screen,self.current)
                                   

                
        def update(self):
            if   self.state == "BACK":
                self.bgeditor()
            elif self.state == "FORE":
                self.editor()
            elif self.state == "QUIT":
                pygame.quit();Tk().quit();sys.exit()
                
            elif self.state == "SAVE":
                    self.savequery()
                
########
def paintfromdict(screen,fore,editor=True):
        for key in fore:
                if editor:
                        screen.blit(pallet[fore[key][0]],key,fore[key][1])
                if not editor:
                        screen.blit(pallet[fore[key][0]],key,(fore[key][1][0]-500,fore[key][1][1],50,50))
                        
def paintback(screen,back):      
        screen.fill(back["colour"],(500,0,1000,700))
        for key in back:
                if key == "colour": pass
                else:
                        screen.blit(bg,key,back[key])
                



########

if __name__ == "__main__":
        mymap = Newmap(realscreen)
        while 1:
            mymap.update()
            shrinkscreen = pygame.transform.scale(mymap.screen,(size))
            screen1.blit(shrinkscreen,(0,0))
            pygame.display.update()






            
